// ***************************************************************************************
//
//	Copyright (C) 2003 Kazuhiko TAMURA. All rights reserved.
//
//	This program is free software; you can redistribute it and/or 
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//	NAME:		Board.java
//	DATE:		2003.5.27
//	CREATOR:	Kazuhiko TAMURA
//
// ***************************************************************************************

package jp.gr.java_conf.ktz.puzzle.hashikake.creator.view;

import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Point;

import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

import java.io.File;

import jp.gr.java_conf.ktz.puzzle.framework.Model;
import jp.gr.java_conf.ktz.puzzle.framework.NullModel;
import jp.gr.java_conf.ktz.puzzle.framework.AbstractDecoratedModel;
import jp.gr.java_conf.ktz.puzzle.framework.ModelConstants;
import jp.gr.java_conf.ktz.puzzle.framework.StateEventCode;
import jp.gr.java_conf.ktz.puzzle.framework.StateManager;

import jp.gr.java_conf.ktz.puzzle.framework.ProblemInfo;

import jp.gr.java_conf.ktz.puzzle.framework.State;
import jp.gr.java_conf.ktz.puzzle.framework.DefaultRenderer;

import jp.gr.java_conf.ktz.puzzle.hashikake.constants.AppColors;
import jp.gr.java_conf.ktz.puzzle.hashikake.constants.Direction;

import jp.gr.java_conf.ktz.puzzle.hashikake.view.BoardView;

import jp.gr.java_conf.ktz.puzzle.hashikake.util.HashikakeStateEventCode;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.ProblemInfoBean;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.ProblemCollection;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.UtilityFuncs;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.gui.GUIUtility;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.ComponentUsher;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.ProblemMarshalable;
import jp.gr.java_conf.ktz.puzzle.hashikake.util.SaveDiscompletedException;

import jp.gr.java_conf.ktz.puzzle.hashikake.creator.model.BoardModel;
import jp.gr.java_conf.ktz.puzzle.hashikake.creator.model.CellActivationModel;

/**
 *	ՖʂǗViewKw
 */
public class Board extends java.awt.Canvas implements BoardView, ProblemMarshalable {
	/** Ֆʂ̕`s_ */
	private DefaultRenderer mRenderer;
	
	/** gbvxModelւ̎Q */
	private Model mModel = NullModel.getInstance();
	
	/** View̐e */
	private BoardView mParent;
	
	/**
	 *	Boardɑ΂ύXtO
	 *	͂n߂ĂAModelύXĂꍇtrueƂȂ 
	 */
	private boolean mIsModified = false;
	
	/**
	 *	ViewKw
	 */
	public void initialize() {
		// Rendereȑ
		mRenderer = RendererFactory.create();
		
		// Model̏
		addModel(new BoardModel());
		addModel(new CellActivationModel());
		
		mModel.nextStateAt(0, 0);
		
		// Canvas̏
		setBackground(AppColors.BACK_COLOR);
		setPieceSize(getPieceSize());
		
		// {[hɃtH[JXڂ
		java.awt.event.FocusEvent aEvent = 
				new java.awt.event.FocusEvent(this, java.awt.event.FocusEvent.FOCUS_GAINED);
		
		java.awt.Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(aEvent);

		// Listener̓o^
		MouseHandler aHandler = new MouseHandler(new Point(0, 0));
		addKeyListener(aHandler);
		addMouseListener(aHandler);
		
	}
	
	/**
	 *	ݏLĂ郂fw肵fɕύXB
	 *	̎ł́Aw肵fAbstractDecoratedModel̏ꍇ
	 *	ݏLĂ郂f̃fŃbv
	 *
	 *	@param	inModel	bv郂f
	 */
	public void addModel(Model inModel) {
		if (inModel instanceof AbstractDecoratedModel) {
			((AbstractDecoratedModel)inModel).addModel(mModel);
		}
		
		mModel = inModel;
	}
	
	/**
	 *	Board̃TCYύX
	 *
	 *	@param	inWidth ύX̕
	 *	@param	inHeight ύX̍
	 */
	public void createBoard(final int inWidth, final int inHeight) {
		if (inWidth == getBoardWidth() && inHeight == getBoardHeight()) {
			return;
		}
		
		mModel.createBoard(inWidth, inHeight);
		mRenderer.setSize(inWidth, inHeight);
		
		java.awt.Dimension aSize = mRenderer.getBoardSize();
		setComponentSize(aSize.width, aSize.height);
		
		// (0, 0)̈ʒuANeBuƂĂ
		Point aInitialPos = new Point(0, 0);
		mModel.nextStateAt(aInitialPos.x, aInitialPos.y); 
	}
	
	/**
	 *	@return Board̕Ԃ
	 */
	public int getBoardWidth() {
		return mModel.getWidth();
	}
	
	/**
	 *	@return Board̍Ԃ
	 */
	public int getBoardHeight() {
		return mModel.getHeight();
	}

	/**
	 *	Clipping̈vZB
	 *	̎ł́ADefaultRendererɃbZ[W]̂
	 *
	 *	@param	inPos ύXꂽՖʂ̈ʒuB
	 *	@return	Clipping̈
	 */
	public Rectangle getClipBounds() {
		java.awt.Insets aInsets = getInsets();
		Rectangle aBounds = mRenderer.getClipBounds(mModel.lastModified());
		aBounds.translate(aInsets.left, aInsets.top);
		
		return aBounds;
	}
	
	/**
	 *	w肳ꂽBoardWn̈ʒuScreenWnɕϊ
	 *	̎ł́ADefaultRendererɃbZ[W]̂
	 *
	 *	@param	inX XWiBoardWnj
	 *	@param	inY YWiBoardWnj
	 *	@return	ϊ̍W
	 */
	public Point calcPortToBoardPos(final int inX, final int inY) {
		java.awt.Insets aInsets = getInsets();
		
		return mRenderer.calcPortToBoardPos(inX-aInsets.left, inY-aInsets.top);
	}
	
	/**
	 *	ՖʂύXĂ邩ǂmF
	 *	̎ł͏falseԂ
	 */
	public boolean isModified() {
		return mIsModified;
	}
	
	/**
	 *	̃R|[lgȉĕ`悷
	 */
	public void update(Graphics inGra) {
		paint(inGra);
	}
	
	/**
	 *	̃R|[lg`悷
	 */
	public void paint(Graphics inGra) {
		Rectangle aBounds = new Rectangle();
		inGra.getClipBounds(aBounds);
		
		java.awt.Insets aInsets = getInsets();
		aBounds.translate(-aInsets.left,-aInsets.top);
		
		inGra.translate(aInsets.left, aInsets.top);

		// eɕύXꍇAύXAύXӏ݂̂ĕ`悷
		if (mModel.isModified()) {
			Point[] aPos = mModel.lastModified();
			
			for (int i = 0; i < aPos.length; ++i) {
				mRenderer.render(aPos[i].x, aPos[i].y, mModel.getCurStateAt(aPos[i].x, aPos[i].y));
			}
		}
		
		// off screen image肾A]
		inGra.drawImage(
				mRenderer.getImage(), 
				aBounds.x, aBounds.y, aBounds.x + aBounds.width, aBounds.y + aBounds.height, 
				aBounds.x, aBounds.y, aBounds.x + aBounds.width, aBounds.y + aBounds.height, 
				this
		);
		
		inGra.translate(-aInsets.left,-aInsets.top);
		
		mModel.flush();
	}
	
	/**
	 *	w肵t@Cɓ͂ۑ
	 *
	 *	@param	inOutFile	o͐
	 */
	public void save(File inOutFile) {
		File aOutFile = inOutFile;
		String aExt = ".xml";
		String aFileName = aOutFile.getAbsolutePath();
		
		// gqA".xml" ĂȂꍇA̎ł̓t@C̍Ō ".xml" ǉ
		if (aFileName.length() != aFileName.toLowerCase().lastIndexOf(aExt) + aExt.length()) {
			aOutFile = new java.io.File(aFileName + aExt);
		}
			
		// Model̓ԂA蕶쐬
		ProblemCollection aCollection = createProblemCollection();
		
		try {
			saveProblem(aOutFile, aCollection);
			
			// saveAFramẽ^Cgw肵t@CɕύX
			setTitle(aOutFile.getAbsolutePath());
			
			mIsModified = false;
			
			System.out.println("save complete");
		}
		catch (SaveDiscompletedException e) {
			System.out.println(e);
		}
	}
	
	private ProblemCollection createProblemCollection() {
		final int aWidth = mModel.getWidth();
		final int aHeight = mModel.getHeight();
		StateManager aManager = StateManager.getInstance();
		
		final int aBufSize = aWidth*aHeight*3;
		StringBuffer aBuf = new StringBuffer(aBufSize);
		
		for (int y = 0; y < aHeight; ++y) {
			for (int x = 0; x < aWidth; ++x) {
				String aStr = aManager.findIdentityOf(mModel.getCurStateAt(x, y));
				aBuf.append(aStr).append(',');
			}
		}
		
		String aProblem = aBuf.substring(0, aBuf.length()-1);
		
		ProblemCollection aCollection = new ProblemCollection();
		aCollection.addProblem(new ProblemInfoBean(aWidth, aHeight, aProblem));
		
		return aCollection;
	}
	
	/**
	 *	w肵t@CɎw肵ۑ
	 *
	 *	@param	inOutFile	o͐
	 */
	public void saveProblem(File inFile, ProblemCollection inCollection) 
											throws SaveDiscompletedException
	{
		try {
			org.jibx.runtime.IBindingFactory aFactory = 
				org.jibx.runtime.BindingDirectory.getFactory(ProblemCollection.class);
	
			org.jibx.runtime.IMarshallingContext aContext = aFactory.createMarshallingContext();
			aContext.setIndent(4);
			
			aContext.marshalDocument(inCollection, "utf-8", null, new java.io.FileOutputStream(inFile));
		}
		catch (Exception e) {
			throw new SaveDiscompletedException("save discomplete");
		}
	}
	
	/**
	 *	w肵蕶load
	 *
	 *	@param inInfo 
	 */
	public void load(ProblemInfo inInfo) {
		createBoard(inInfo.getWidth(), inInfo.getHeight());
		mModel.nextStateAt(0, 0); // (0, 0)̈ʒuANeBuƂĂ
		
		mModel.setProblem(inInfo);
		
		MenuManager.currentMenuManager().setEnabledFor(MenuManager.ITEM_SAVE, false);
		mIsModified = false;
		
		if (mModel.isModified()) {
			Rectangle aBounds = getClipBounds();
			repaint(aBounds.x, aBounds.y, aBounds.width, aBounds.height);
		}		
	}

	/**
	 *	Ֆʂ
	 */
	public void clear() {
		mModel.reset();
		
		if (mModel.isModified()) {
				
				Rectangle aBounds = getClipBounds();
				repaint(aBounds.x, aBounds.y, aBounds.width, aBounds.height);
		}
	}
	
	/**
	 *	BoardKwƂÅKw̐eݒ肷
	 *
	 *	@param	inBoard	̊Kw̐eƂȂBoard
	 */
	public void setParent(BoardView inParentBoard) {
		mParent = inParentBoard;
	}
	
	
	/**
	 *	@return PiecẽTCYԂ
	 */
	public int getPieceSize() {
		return mRenderer.getPieceSize().height;
	}
	
	/**
	 *	Board1s[X̃TCYZbg
	 *
	 *	@param	inSize ZTCY
	 */
	public void setPieceSize(final int inSize) {
		mParent.setPieceSize(inSize);
	}
	
	/**
	 *	@return	gƊ֘AtꂽCOmponentԂ
	 */
	public java.awt.Component getComponent() {
		return this;
	}
		
	/**
	 *	w肵^CgZbg
	 *
	 *	@param	^Cg
	 */
	public void setTitle(String inTitle) {
		mParent.setTitle(inTitle);
	}

	/**
	 *	Board̃^CgԂ
	 *
	 *	@return	^Cg
	 */
	public String getTitle() {
		return mParent.getTitle();
	}
	
	/**
	 *	̃R|[lgInsetsԂ
	 *
	 *	@return	̃R|[lgInsets
	 */
	public java.awt.Insets getInsets() {
		final int aPiece = getPieceSize();
		
		return new java.awt.Insets(aPiece, aPiece, 0, 0);
	}
	
	/**
	 *	Board̃TCYZbg
	 *
	 *	@param	inWidth 
	 *	@param	inHeight 
	 */
	public void setComponentSize(final int inWidth, final int inHeight) {
		java.awt.Insets aInsets = getInsets();
		
		final int aWidth = inWidth + aInsets.left + aInsets.right;
		final int aHeight = inHeight + aInsets.top + aInsets.bottom;
		
		setSize(aWidth, aHeight);
		mParent.setComponentSize(aWidth, aHeight);
	}
	
	/**
	 *	BoardɃtH[JXڂǂ߂
	 */
	public void setFocus(boolean inFocused) {
		mParent.setFocus(inFocused);
	}
	
	/**
	 *	BoardɃtH[JX݂邩ǂ`FbN
	 *
	 *	@return	tH[JXꍇtrueԂB
	 */
	public boolean isFocused() {
		return mParent.isFocused();
	}
	
	private void enableMenu(String inMenuID, boolean inEnabled) {
		if (! mIsModified) {
			if (mModel.isModified()) {
				MenuManager.currentMenuManager().setEnabledFor(inMenuID, inEnabled);
			}	
			
			mIsModified = true; 
		}
	}
	
	private class MouseHandler implements 
									KeyListener, MouseListener
	{
		private final Point ILLEGAL = ModelConstants.ILLEGAL_POS;
		
		private Point mActivePiece;
		
		MouseHandler(Point inInitPos) {
			mActivePiece = inInitPos;
		}
		
		public void keyPressed(KeyEvent inEvent) {
			// modifierL[ƂɉĂꍇ́ȀŔB
			if (0 < inEvent.getModifiers()) return;
			
			final int aPressedCode = inEvent.getKeyCode();
			
			// DeleteL[ABack spaceL[ꂽꍇ̓Z̏Ԃ󔒏Ԃɖ߂
			if (aPressedCode == KeyEvent.VK_DELETE || aPressedCode == KeyEvent.VK_BACK_SPACE) 
			{
				StateEventCode aCode = HashikakeStateEventCode.createSpaceCode();
				mModel.nextStateAt(ILLEGAL.x, ILLEGAL.y, aCode);
				
				enableMenu(MenuManager.ITEM_SAVE, true);
			}
			else if (aPressedCode == KeyEvent.VK_LEFT || aPressedCode == KeyEvent.VK_RIGHT
				|| aPressedCode == KeyEvent.VK_UP || aPressedCode == KeyEvent.VK_DOWN)
			{
				// ꂽL[J[\L[̏ꍇ
				// ɑאڂʒuactiveɂ
				// ̈ʒudeactiveɂ
				
				// אڈʒu̎擾
				Direction aDirection = UtilityFuncs.resolveDirectionOf(aPressedCode);
				Point aDif = aDirection.getDifference();
				
				StateEventCode aCode = UtilityFuncs.getSelectionEventCode();
//				StateEventCode aCode = UtilityFuncs.getDirectionEventCode(aDirection)
				mModel.nextStateAt(aDif.x, aDif.y, aCode);
				
				if (mModel.isModified()) {
					mActivePiece.translate(aDif.x, aDif.y);
					final int aPieceSize = getPieceSize();
					
					Rectangle aBounds = new Rectangle(
						 		getX() + mActivePiece.x*aPieceSize, 
						 		getY() + mActivePiece.y*aPieceSize, 
						 		aPieceSize, aPieceSize
					);
					
					KeyScrollEvent aEvent = new KeyScrollEvent(mParent, aDirection, aBounds);
					java.awt.Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(aEvent);
				}
			}
			else {
				try {
					// ꂽL[ł΁A
					// Z̏Ԃw肵̏ԂɑJڂ
					final int aVal = Integer.parseInt(KeyEvent.getKeyText(aPressedCode));
					
					// ́A1 ` 8̂ݔF߂B
					if (aVal > 0 && aVal < 9) {
						StateEventCode aCode = HashikakeStateEventCode.valueOf(String.valueOf(aVal));
						mModel.nextStateAt(ILLEGAL.x, ILLEGAL.y, aCode);
						enableMenu(MenuManager.ITEM_SAVE, true);
					}
				}
				catch (NumberFormatException e) {
					// ȊÕL[ł΁AȂ
					return;
				}
			}

			// Model̏ԂύXĂꍇ̂ݍĕ`悷B
			if (mModel.isModified()) {
				Rectangle aBounds = getClipBounds();
				repaint(aBounds.x, aBounds.y, aBounds.width, aBounds.height);
			}
		}
		
		public void mousePressed(MouseEvent inEvent) {

			
			// BoardfocusꍇAmouse movehandling
			if (! isFocused()) return;

			final int aX = inEvent.getX();
			final int aY = inEvent.getY();
			
			Point aPos = calcPortToBoardPos(aX, aY);

			// aPos̈ʒuactiveɂ
			mModel.nextStateAt(aPos.x, aPos.y);

			// Model̏ԂύXĂꍇ̂ݍĕ`悷B
			if (mModel.isModified()) {
				// activepieceL^Ă
				mActivePiece = aPos;
				
				Rectangle aBounds = getClipBounds();
				
				repaint(aBounds.x, aBounds.y, aBounds.width, aBounds.height);
//				repaint(0, 0, 0, 0);
			}
		}
		
		public void keyReleased(KeyEvent inEvent) {}
		public void keyTyped(KeyEvent inEvent) {}
		
		public void mouseClicked(MouseEvent inEvent) {}
		public void mouseReleased(MouseEvent inEvent) {}
		public void mouseEntered(MouseEvent inEvent) {}
		public void mouseExited(MouseEvent inEvent) {}
	}
}

